/**
 * Description placeholder
 *
 * @typedef {CBS_MaterialIconFontSettings}
 */
type CBS_MaterialIconFontSettings = {
    [key: string]: string | number;
}

/**
 * Description placeholder
 *
 * @class CBS_MaterialIcon
 * @typedef {CBS_MaterialIcon}
 * @extends {CBS_Component}
 */
class CBS_MaterialIcon extends CBS_Component {
    /**
     * Creates an instance of CBS_MaterialIcon.
     *
     * @constructor
     * @param {?CBS_Options} [options]
     */
    constructor(options?: CBS_Options) {
        super(options);

        this._el = document.createElement('i');
        this._el.classList.add('material-icons');
    }

    /**
     * Description placeholder
     *
     * @type {(string | number)}
     */
    set weight(weight: string|number) {
        this.settings = {
            ...this.settings,
            wght: weight,
        };
    }/**
     * Description placeholder
     */
    ;

    /**
     * Description placeholder
     *
     * @type {(string|number)}
     */
    get weight(): string|number {
        return this.settings?.['wght'] || 400;
    }

    /**
     * Description placeholder
     *
     * @type {string}
     */
    set icon(icon: string) {
        this._el.innerHTML = icon;
    }

    /**
     * Description placeholder
     *
     * @type {string}
     */
    get icon(): string {
        return this._el.innerHTML;
    }

    /**
     * Description placeholder
     *
     * @type {(string | number)}
     */
    set grade(grade: string|number) {
        this.settings = {
            ...this.settings,
            GRAD: grade,
        };
    }/**
     * Description placeholder
     */
    ;

    /**
     * Description placeholder
     *
     * @type {(string|number)}
     */
    get grade(): string|number {
        return this.settings?.['GRAD'] || 0;
    }

    /**
     * Description placeholder
     *
     * @type {(string | number)}
     */
    set opticalSize(opticalSize: string|number) {
        this.settings = {
            ...this.settings,
            opsz: opticalSize,
        };
    }/**
     * Description placeholder
     */
    ;

    /**
     * Description placeholder
     *
     * @type {(string|number)}
     */
    get opticalSize(): string|number {
        return this.settings?.['opsz'] || 0;
    }

    /**
     * Description placeholder
     *
     * @type {(string | number)}
     */
    set fill(fill: string|number) {
        this.settings = {
            ...this.settings,
            FILL: fill,
        };
    }

    /**
     * Description placeholder
     *
     * @type {(string|number)}
     */
    get fill(): string|number {
        return this.settings?.['FILL'] || 0;
    }

    /**
     * Description placeholder
     *
     * @private
     * @type {CBS_MaterialIconFontSettings}
     */
    private get settings(): CBS_MaterialIconFontSettings {
        const { fontVariationSettings } = this._el.style;

        let output:CBS_MaterialIconFontSettings = {};

        if (fontVariationSettings) {
            const settings = fontVariationSettings.split(',');

            settings.forEach(setting => {
                const [key, value] = setting.split(' ');
                if (['wght', 'GRAD', 'FILL',].indexOf(key) >= 0)
                output[key] = value;
            });
        }

        return output;
    }

    /**
     * Description placeholder
     *
     * @private
     * @type {CBS_MaterialIconFontSettings}
     */
    private set settings(settings: CBS_MaterialIconFontSettings) {
        this._el.style.fontVariationSettings = Object.keys(settings).map(key => `${key} ${settings[key]}`).join(',');
    }
}

/**
 * Description placeholder
 *
 * @param {?string} [prefix]
 */
const CBS_GenerateMaterialIcons = (prefix?: string) => {
    const icons: string[] = JSON.parse(
        '["search","search","home","menu","close","settings","done","expand_more","check_circle","favorite","add","delete","arrow_back","star","chevron_right","logout","arrow_forward_ios","add_circle","cancel","arrow_back_ios","arrow_forward","arrow_drop_down","more_vert","check","check_box","toggle_on","grade","open_in_new","check_box_outline_blank","refresh","login","chevron_left","expand_less","radio_button_unchecked","more_horiz","apps","arrow_right_alt","radio_button_checked","download","remove","toggle_off","bolt","arrow_upward","filter_list","delete_forever","autorenew","key","arrow_downward","sort","sync","add_box","block","arrow_back_ios_new","restart_alt","menu_open","shopping_cart_checkout","expand_circle_down","backspace","arrow_circle_right","undo","done_all","arrow_right","do_not_disturb_on","open_in_full","double_arrow","manage_search","sync_alt","zoom_in","done_outline","drag_indicator","fullscreen","keyboard_double_arrow_right","star_half","settings_accessibility","ios_share","arrow_drop_up","reply","exit_to_app","unfold_more","library_add","cached","select_check_box","terminal","change_circle","disabled_by_default","swap_horiz","swap_vert","app_registration","download_for_offline","close_fullscreen","arrow_circle_left","arrow_circle_up","file_open","minimize","open_with","keyboard_double_arrow_left","dataset","add_task","keyboard_double_arrow_down","start","keyboard_voice","create_new_folder","forward","downloading","settings_applications","compare_arrows","redo","publish","zoom_out","arrow_left","html","token","switch_access_shortcut","arrow_circle_down","fullscreen_exit","sort_by_alpha","delete_sweep","indeterminate_check_box","first_page","keyboard_double_arrow_up","view_timeline","settings_backup_restore","arrow_drop_down_circle","assistant_navigation","sync_problem","clear_all","density_medium","heart_plus","filter_alt_off","expand","last_page","subdirectory_arrow_right","download_done","unfold_less","arrow_outward","123","swipe_left","auto_mode","saved_search","system_update_alt","place_item","maximize","javascript","output","search_off","swipe_up","fit_screen","select_all","dynamic_form","hide_source","swipe_right","switch_access_shortcut_add","browse_gallery","css","density_small","check_small","assistant_direction","file_download_done","move_up","youtube_searched_for","swap_horizontal_circle","data_thresholding","install_mobile","move_down","restore_from_trash","dataset_linked","abc","enable","install_desktop","keyboard_command_key","view_kanban","reply_all","browse_activity","switch_left","compress","swipe_down","swap_vertical_circle","remove_done","filter_list_off","apps_outage","switch_right","hide","swipe_vertical","more_up","star_rate","sync_disabled","pinch","keyboard_control_key","eject","key_off","php","subdirectory_arrow_left","view_cozy","do_not_disturb_off","transcribe","send_time_extension","width_normal","view_comfy_alt","heart_minus","share_reviews","width_full","unfold_more_double","view_compact_alt","file_download_off","extension_off","open_in_new_off","check_indeterminate_small","more_down","width_wide","repartition","swipe_left_alt","density_large","swipe_down_alt","swipe_right_alt","swipe_up_alt","unfold_less_double","keyboard_option_key","hls","hls_off","cycle","file_upload_off","rebase","rebase_edit","expand_content","empty_dashboard","magic_exchange","sync_saved_locally","quick_reference_all","acute","preliminary","quick_reference","clock_loader_60","data_alert","deployed_code","data_check","data_info_alert","new_window","step_into","point_scan","search_check","magnification_small","magnification_large","captive_portal","clock_loader_40","star_rate_half","clock_loader_90","drag_pan","clock_loader_10","left_click","patient_list","unknown_med","move_group","arrow_insert","capture","clock_loader_20","left_panel_close","question_exchange","chip_extraction","iframe","chronic","input_circle","bottom_right_click","clock_loader_80","go_to_line","left_panel_open","right_panel_close","shelf_position","right_click","step","error_med","resize","step_out","all_match","bottom_panel_open","drag_click","step_over","app_badging","output_circle","right_panel_open","shelf_auto_hide","amend","page_info","pip","arrow_range","arrow_top_right","event_list","jump_to_element","move_selection_up","rule_settings","arrow_top_left","arrows_outward","back_to_tab","bottom_panel_close","bubbles","iframe_off","move_selection_down","move_selection_right","open_in_new_down","position_bottom_left","position_bottom_right","position_top_right","reopen_window","share_windows","stack","switch_access","heart_check","move_selection_left","pip_exit","stack_off","stack_star","person","person","group","share","thumb_up","groups","person_add","public","handshake","support_agent","face","sentiment_satisfied","rocket_launch","group_add","workspace_premium","psychology","diversity_3","emoji_objects","water_drop","eco","pets","travel_explore","mood","sunny","quiz","health_and_safety","sentiment_dissatisfied","sentiment_very_satisfied","military_tech","thumb_down","gavel","recycling","diamond","monitor_heart","emoji_people","diversity_1","workspaces","vaccines","compost","forest","recommend","waving_hand","person_remove","wc","medication","group_work","sentiment_very_dissatisfied","sentiment_neutral","diversity_2","front_hand","cruelty_free","man","medical_information","psychology_alt","coronavirus","add_reaction","rocket","female","potted_plant","emoji_nature","rainy","person_off","woman","connect_without_contact","cookie","male","mood_bad","bedtime","solar_power","thunderstorm","communication","groups_2","partly_cloudy_day","cloudy","thumbs_up_down","emoji_flags","masks","hive","heart_broken","sentiment_extremely_dissatisfied","clear_day","boy","whatshot","cloudy_snowing","emoji_food_beverage","emoji_transportation","wind_power","elderly","face_6","reduce_capacity","sick","pregnant_woman","face_3","bloodtype","group_remove","medication_liquid","egg","groups_3","clear_night","co2","weight","follow_the_signs","skull","face_4","oil_barrel","transgender","elderly_woman","clean_hands","sanitizer","person_2","bring_your_own_ip","public_off","face_2","social_distance","routine","sign_language","south_america","sunny_snowing","emoji_symbols","garden_cart","flood","egg_alt","face_5","cyclone","girl","person_4","dentistry","tsunami","group_off","outdoor_garden","partly_cloudy_night","severe_cold","snowing","person_3","tornado","vaping_rooms","landslide","foggy","safety_divider","woman_2","no_adult_content","volcano","man_2","blind","18_up_rating","6_ft_apart","vape_free","not_accessible","man_4","radiology","rib_cage","hand_bones","bedtime_off","rheumatology","man_3","orthopedics","tibia","skeleton","humerus","agender","femur","foot_bones","tibia_alt","femur_alt","humerus_alt","ulna_radius","ulna_radius_alt","diversity_4","specific_gravity","partner_exchange","breastfeeding","cognition","eyeglasses","psychiatry","footprint","labs","social_leaderboard","neurology","vital_signs","nutrition","demography","globe_asia","clinical_notes","stethoscope","sentiment_excited","altitude","lab_research","home_health","recent_patient","dew_point","conditions","globe_uk","taunt","wrist","helicopter","prayer_times","sentiment_stressed","share_off","metabolism","sentiment_content","sentiment_sad","cardiology","sentiment_frustrated","stethoscope_check","body_system","glucose","infrared","weather_hail","barefoot","microbiology","sentiment_calm","stethoscope_arrow","cookie_off","earthquake","ent","oncology","short_stay","water_lux","water_voc","allergies","cheer","deceased","endocrinology","explosion","genetics","gynecology","hematology","mixture_med","ophthalmology","oxygen_saturation","prescriptions","pulmonology","ward","allergy","body_fat","congenital","dermatology","emoticon","humidity_percentage","immunology","inpatient","lab_panel","medical_mask","moving_beds","nephrology","oral_disease","outpatient","outpatient_med","pediatrics","salinity","sentiment_worried","surgical","symptoms","syringe","urology","water_do","water_orp","water_ph","weather_mix","wounds_injuries","admin_meds","fluid","fluid_balance","fluid_med","gastroenterology","pill","pill_off","respiratory_rate","total_dissolved_solids","water_bottle","falling","mist","procedure","rainy_heavy","rainy_light","rainy_snow","snowing_heavy","water_bottle_large","water_ec","account_circle","account_circle","info","visibility","calendar_month","schedule","help","language","warning","lock","error","visibility_off","verified","manage_accounts","task_alt","history","event","bookmark","calendar_today","tips_and_updates","question_mark","lightbulb","fingerprint","category","update","lock_open","priority_high","code","build","date_range","upload_file","supervisor_account","event_available","ads_click","today","settings_suggest","touch_app","preview","pending","stars","new_releases","account_box","celebration","how_to_reg","translate","bug_report","push_pin","alarm","edit_calendar","edit_square","label","event_note","extension","rate_review","record_voice_over","web","hourglass_empty","published_with_changes","support","notification_important","help_center","upload","accessibility_new","bookmarks","pan_tool_alt","supervised_user_circle","collections_bookmark","dangerous","interests","all_inclusive","rule","change_history","priority","event_upcoming","build_circle","wysiwyg","pan_tool","api","circle_notifications","hotel_class","manage_history","accessible","web_asset","upgrade","lock_reset","bookmark_add","input","event_busy","flutter_dash","more_time","save_as","backup","model_training","accessibility","alarm_on","dynamic_feed","pageview","home_app_logo","perm_contact_calendar","label_important","history_toggle_off","square_foot","approval","more","swipe","assistant","component_exchange","event_repeat","bookmark_added","app_shortcut","unpublished","open_in_browser","offline_bolt","notification_add","no_accounts","free_cancellation","background_replace","running_with_errors","anchor","webhook","hourglass_full","3d_rotation","lock_person","new_label","lock_clock","accessible_forward","auto_delete","add_alert","domain_verification","smart_button","outbound","hand_gesture","settings_power","tab","chrome_reader_mode","online_prediction","gesture","edit_notifications","generating_tokens","lightbulb_circle","find_replace","backup_table","offline_pin","wifi_protected_setup","ad_units","http","bookmark_remove","alarm_add","pinch_zoom_out","on_device_training","snooze","code_off","batch_prediction","pinch_zoom_in","commit","hourglass_disabled","settings_overscan","polymer","logo_dev","youtube_activity","time_auto","person_add_disabled","voice_over_off","alarm_off","update_disabled","timer_10_alt_1","rounded_corner","label_off","all_out","timer_3_alt_1","tab_unselected","rsvp","web_asset_off","pin_invoke","pin_end","code_blocks","approval_delegation","arrow_selector_tool","problem","visibility_lock","award_star","auto_label","settings_account_box","draft_orders","release_alert","pan_zoom","account_circle_off","alarm_smart_wake","bookmark_manager","help_clinic","shift","watch_screentime","preview_off","lock_open_right","measuring_tape","shift_lock","domain_verification_off","gesture_select","warning_off","water_lock","ad_off","supervised_user_circle_off","mail","mail","call","notifications","send","chat","link","forum","inventory_2","phone_in_talk","contact_support","chat_bubble","notifications_active","alternate_email","sms","comment","power_settings_new","hub","person_search","import_contacts","contact_mail","contacts","live_help","forward_to_inbox","mark_email_unread","lan","reviews","contact_phone","mode_comment","hourglass_top","inbox","outgoing_mail","drafts","hourglass_bottom","mark_email_read","sms_failed","link_off","calendar_add_on","phone_enabled","add_comment","speaker_notes","perm_phone_msg","co_present","topic","call_end","notifications_off","cell_tower","mark_chat_unread","schedule_send","dialpad","call_made","satellite_alt","mark_unread_chat_alt","unarchive","3p","cancel_presentation","mark_as_unread","move_to_inbox","attach_email","phonelink_ring","next_plan","unsubscribe","phone_callback","call_received","settings_phone","call_split","present_to_all","add_call","markunread_mailbox","all_inbox","phone_forwarded","voice_chat","mail_lock","attribution","voicemail","duo","contact_emergency","mark_chat_read","upcoming","phone_disabled","outbox","swap_calls","phonelink_lock","spoke","cancel_schedule_send","notifications_paused","ring_volume","picture_in_picture_alt","quickreply","phone_missed","comment_bank","send_and_archive","chat_add_on","settings_bluetooth","phonelink_erase","picture_in_picture","comments_disabled","video_chat","score","pause_presentation","cell_wifi","speaker_phone","speaker_notes_off","auto_read_play","mms","call_merge","play_for_work","call_missed_outgoing","wifi_channel","call_missed","calendar_apps_script","phone_paused","rtt","auto_read_pause","phone_locked","wifi_calling","dialer_sip","nat","chat_apps_script","sip","phone_bluetooth_speaker","e911_avatar","inbox_customize","chat_error","chat_paste_go","phonelink_ring_off","network_manage","signal_cellular_add","wifi_proxy","call_log","call_quality","wifi_add","edit","edit","photo_camera","filter_alt","image","navigate_next","tune","timer","picture_as_pdf","circle","palette","auto_awesome","add_a_photo","magic_button","photo_library","navigate_before","auto_stories","add_photo_alternate","brush","imagesmode","nature","flash_on","wb_sunny","camera","straighten","looks_one","landscape","timelapse","slideshow","grid_on","rotate_right","crop_square","adjust","style","crop_free","aspect_ratio","brightness_6","photo","nature_people","filter_vintage","crop","image_search","movie_filter","blur_on","center_focus_strong","contrast","face_retouching_natural","compare","looks_two","rotate_left","colorize","flare","filter_none","wb_incandescent","filter_drama","healing","looks_3","wb_twilight","brightness_5","invert_colors","lens","animation","opacity","incomplete_circle","broken_image","filter_center_focus","add_to_photos","brightness_4","flip","flash_off","center_focus_weak","auto_awesome_motion","mic_external_on","flip_camera_android","lens_blur","details","grain","no_photography","panorama","image_not_supported","web_stories","dehaze","gif_box","flaky","loupe","exposure_plus_1","settings_brightness","texture","auto_awesome_mosaic","looks_4","filter_1","timer_off","flip_camera_ios","camera_enhance","panorama_fish_eye","filter","view_compact","brightness_1","photo_camera_front","control_point_duplicate","photo_album","brightness_7","transform","linked_camera","view_comfy","crop_16_9","looks","hide_image","looks_5","exposure","photo_filter","rotate_90_degrees_ccw","filter_hdr","brightness_3","gif","leak_add","hdr_strong","crop_7_5","gradient","vrpano","camera_roll","hdr_auto","crop_portrait","blur_circular","motion_photos_auto","rotate_90_degrees_cw","brightness_2","photo_size_select_small","shutter_speed","looks_6","camera_front","flash_auto","filter_2","crop_landscape","filter_tilt_shift","deblur","monochrome_photos","astrophotography_auto","crop_5_4","hdr_weak","night_sight_auto","filter_4","filter_3","motion_photos_paused","crop_rotate","crop_3_2","tonality","switch_camera","photo_frame","exposure_zero","photo_size_select_large","macro_off","filter_frames","ev_shadow","fluorescent","party_mode","raw_on","motion_blur","exposure_plus_2","photo_camera_back","blur_linear","exposure_neg_1","wb_iridescent","filter_b_and_w","panorama_horizontal","switch_video","motion_photos_off","filter_5","blur_medium","invert_colors_off","face_retouching_off","filter_7","burst_mode","panorama_photosphere","hdr_on","grid_off","filter_9_plus","filter_8","auto_fix","blur_short","filter_9","timer_10","dirty_lens","wb_shade","no_flash","filter_6","trail_length","image_aspect_ratio","exposure_neg_2","vignette","timer_3","leak_remove","60fps_select","blur_off","30fps_select","perm_camera_mic","mic_external_off","trail_length_medium","camera_rear","panorama_vertical","trail_length_short","auto_fix_high","autofps_select","night_sight_auto_off","panorama_wide_angle","mp","hdr_off","hdr_on_select","24mp","hdr_enhanced_select","22mp","astrophotography_off","auto_fix_normal","10mp","12mp","18mp","wb_auto","hdr_auto_select","raw_off","9mp","hdr_plus","13mp","20mp","7mp","15mp","hdr_off_select","5mp","hevc","16mp","19mp","14mp","23mp","2mp","8mp","3mp","6mp","11mp","21mp","17mp","4mp","auto_fix_off","gallery_thumbnail","settings_photo_camera","settings_panorama","motion_mode","settings_motion_mode","settings_night_sight","background_dot_large","settings_video_camera","50mp","background_grid_small","low_density","macro_auto","settings_b_roll","settings_cinematic_blur","settings_slow_motion","settings_timelapse","high_density","shopping_cart","shopping_cart","payments","shopping_bag","monitoring","credit_card","receipt_long","attach_money","storefront","sell","trending_up","database","account_balance","work","paid","account_balance_wallet","analytics","insights","query_stats","store","savings","monetization_on","calculate","qr_code_scanner","bar_chart","add_shopping_cart","account_tree","receipt","redeem","currency_exchange","trending_flat","shopping_basket","qr_code_2","domain","qr_code","precision_manufacturing","leaderboard","corporate_fare","timeline","currency_rupee","insert_chart","wallet","show_chart","euro","work_history","meeting_room","credit_score","barcode_scanner","pie_chart","loyalty","copyright","barcode","conversion_path","track_changes","auto_graph","trending_down","price_check","euro_symbol","schema","add_business","add_card","card_membership","currency_bitcoin","price_change","production_quantity_limits","donut_large","tenancy","data_exploration","bubble_chart","donut_small","contactless","money","stacked_line_chart","stacked_bar_chart","toll","money_off","cases","currency_yen","currency_pound","area_chart","atr","remove_shopping_cart","room_preferences","add_chart","shop","domain_add","card_travel","grouped_bar_chart","legend_toggle","scatter_plot","credit_card_off","ssid_chart","mediation","candlestick_chart","currency_ruble","waterfall_chart","full_stacked_bar_chart","domain_disabled","strikethrough_s","shop_two","next_week","atm","multiline_chart","currency_lira","currency_yuan","no_meeting_room","currency_franc","autopay","contactless_off","family_history","podium","chart_data","order_approve","flowsheet","conveyor_belt","bar_chart_4_bars","auto_meeting_room","forklift","front_loader","pallet","inactive_order","qr_code_2_add","barcode_reader","conversion_path_off","trolley","order_play","pin_drop","pin_drop","location_on","map","home_pin","explore","restaurant","flag","my_location","local_fire_department","person_pin_circle","local_mall","near_me","where_to_vote","business_center","east","restaurant_menu","handyman","factory","local_library","home_work","medical_services","layers","local_activity","share_location","emergency","north_east","add_location","fastfood","warehouse","navigation","person_pin","local_parking","home_repair_service","local_hospital","south","local_police","zoom_out_map","location_searching","local_florist","location_away","crisis_alert","west","local_gas_station","park","maps_ugc","cleaning_services","local_atm","package","360","electrical_services","north","flag_circle","add_location_alt","directions","fmd_bad","theater_comedy","local_drink","location_home","local_pizza","local_post_office","not_listed_location","wine_bar","beenhere","local_convenience_store","signpost","alt_route","location_automation","tour","church","trip_origin","traffic","local_laundry_service","safety_check","ev_station","takeout_dining","moving","zoom_in_map","soup_kitchen","stadium","transfer_within_a_station","location_off","pest_control","connecting_airports","multiple_stop","wrong_location","edit_location","plumbing","mode_of_travel","minor_crash","south_east","local_pharmacy","add_road","fire_truck","castle","dry_cleaning","set_meal","baby_changing_station","layers_clear","edit_location_alt","mosque","north_west","local_car_wash","edit_attributes","run_circle","transit_enterexit","sos","satellite","edit_road","south_west","add_home","streetview","kebab_dining","airline_stops","fire_hydrant","local_see","assist_walker","add_home_work","flight_class","no_meals","remove_road","synagogue","fort","temple_buddhist","location_disabled","compass_calibration","temple_hindu","explore_off","pest_control_rodent","near_me_disabled","directions_alt","pergola","directions_off","directions_alt_off","move_location","moving_ministry","move","description","description","content_copy","dashboard","edit_note","menu_book","grid_view","list","folder","list_alt","inventory","folder_open","article","fact_check","attach_file","format_list_bulleted","assignment","task","checklist","cloud_upload","draft","summarize","feed","draw","cloud","newspaper","file_copy","view_list","note_add","border_color","book","history_edu","design_services","pending_actions","format_quote","post_add","request_quote","cloud_download","drag_handle","contact_page","table","space_dashboard","archive","content_paste","percent","attachment","assignment_ind","format_list_numbered","assignment_turned_in","tag","table_chart","sticky_note_2","dashboard_customize","text_fields","reorder","format_bold","integration_instructions","find_in_page","note","text_snippet","document_scanner","checklist_rtl","note_alt","cloud_sync","edit_document","table_rows","perm_media","cloud_done","title","table_view","content_cut","data_object","cut","notes","subject","functions","format_italic","content_paste_search","format_color_fill","folder_shared","plagiarism","horizontal_rule","file_present","folder_copy","format_align_left","ballot","team_dashboard","format_paint","add_link","cloud_off","read_more","view_column","difference","view_agenda","format_size","format_underlined","vertical_align_top","toc","height","vertical_align_bottom","copy_all","drive_folder_upload","view_week","format_color_text","assignment_late","view_module","drive_file_move","low_priority","assignment_return","format_align_center","folder_special","segment","calendar_view_month","polyline","folder_zip","square","breaking_news_alt_1","format_align_right","grading","view_headline","linear_scale","view_quilt","edit_off","view_carousel","text_increase","request_page","view_sidebar","pages","text_format","format_align_justify","calendar_view_week","hexagon","numbers","docs_add_on","folder_delete","format_shapes","forms_add_on","imagesearch_roller","join_full","calendar_view_day","video_file","cloud_queue","format_list_numbered_rtl","font_download","join_inner","add_to_drive","content_paste_go","restore_page","rectangle","vertical_split","format_color_reset","rule_folder","view_stream","cloud_circle","format_indent_increase","spellcheck","assignment_returned","data_array","align_horizontal_left","pivot_table_chart","text_decrease","deselect","vertical_align_center","pentagon","merge_type","space_bar","view_day","format_strikethrough","flip_to_front","join_left","border_all","short_text","shape_line","format_line_spacing","line_weight","horizontal_split","format_indent_decrease","align_horizontal_center","join_right","snippet_folder","subtitles_off","align_vertical_bottom","folder_off","align_horizontal_right","glyphs","format_clear","insert_page_break","content_paste_off","vertical_distribute","function","superscript","horizontal_distribute","line_axis","line_style","flip_to_back","align_vertical_center","align_vertical_top","margin","clarify","wrap_text","view_array","subscript","border_clear","border_style","border_outer","amp_stories","type_specimen","text_rotate_vertical","padding","forms_apps_script","border_vertical","text_rotation_none","format_textdirection_l_to_r","format_overline","docs_apps_script","border_horizontal","font_download_off","format_textdirection_r_to_l","text_rotation_angleup","border_bottom","border_top","text_rotation_down","border_left","text_rotation_angledown","border_inner","text_rotate_up","border_right","format_h1","assignment_add","finance_chip","view_column_2","join","format_underlined_squiggle","counter_1","format_paragraph","format_h2","format_image_left","overview","slide_library","format_list_bulleted_add","format_h3","format_image_right","format_h5","frame_inspect","variables","format_h6","format_h4","process_chart","voting_chip","location_chip","counter_2","lab_profile","format_ink_highlighter","signature","counter_3","equal","business_chip","export_notes","shapes","add_notes","cell_merge","counter_4","text_select_move_forward_character","frame_source","diagnosis","list_alt_add","table_rows_narrow","unknown_document","decimal_increase","insert_text","line_end_arrow_notch","regular_expression","reset_image","line_start","stylus_laser_pointer","table_chart_view","format_letter_spacing","line_end","grid_guides","line_end_square","match_case","scan_delete","ungroup","scan","source_notes","align_justify_space_between","counter_5","counter_6","language_chinese_quick","line_end_arrow","other_admission","stroke_full","align_justify_space_around","draw_collage","folder_managed","folder_supervised","line_end_circle","line_end_diamond","line_start_circle","sheets_rtl","smb_share","tab_close","tab_move","text_select_jump_to_beginning","top_panel_open","width","align_justify_space_even","align_space_between","draw_abstract","frame_reload","line_start_square","match_word","select","tab_new_right","text_select_move_forward_word","text_select_start","thumbnail_bar","top_panel_close","align_justify_center","align_justify_flex_end","align_justify_flex_start","align_space_around","align_space_even","attach_file_add","counter_7","counter_8","fit_page","fit_width","format_text_overflow","format_text_wrap","heap_snapshot_thumbnail","highlighter_size_4","language_chinese_dayi","language_chinese_pinyin","language_chinese_wubi","language_gb_english","language_korean_latin","language_us","line_curve","pen_size_2","pen_size_5","stroke_partial","tab_close_right","tab_duplicate","text_select_move_down","text_select_move_up","align_center","align_end","align_flex_center","align_flex_end","align_flex_start","align_items_stretch","align_justify_stretch","align_self_stretch","align_start","align_stretch","counter_0","counter_9","decimal_decrease","flex_direction","flex_no_wrap","flex_wrap","format_letter_spacing_2","format_letter_spacing_standard","format_letter_spacing_wide","format_letter_spacing_wider","format_text_clip","heap_snapshot_large","heap_snapshot_multiple","highlighter_size_1","highlighter_size_2","highlighter_size_3","highlighter_size_5","language_chinese_array","language_chinese_cangjie","language_french","language_international","language_pinyin","language_us_colemak","language_us_dvorak","letter_switch","line_start_arrow","line_start_arrow_notch","line_start_diamond","pen_size_1","pen_size_3","pen_size_4","special_character","tab_group","tab_recent","text_select_end","text_select_jump_to_end","text_select_move_back_character","text_select_move_back_word","play_arrow","play_arrow","play_circle","mic","videocam","volume_up","pause","music_note","library_books","movie","skip_next","speed","replay","volume_off","view_in_ar","pause_circle","fiber_manual_record","skip_previous","stop_circle","stop","equalizer","subscriptions","video_library","fast_forward","playlist_add","video_call","repeat","volume_mute","shuffle","mic_off","library_music","hearing","podcasts","playlist_add_check","fast_rewind","sound_detection_dog_barking","queue_music","video_camera_front","subtitles","volume_down","play_pause","album","radio","av_timer","discover_tune","library_add_check","videocam_off","closed_caption","stream","forward_10","not_started","playlist_play","replay_10","fiber_new","branding_watermark","recent_actors","text_to_speech","playlist_remove","interpreter_mode","slow_motion_video","frame_person","playlist_add_check_circle","settings_voice","video_settings","featured_play_list","audio_file","sound_detection_loud_sound","lyrics","play_lesson","hd","repeat_one","call_to_action","add_to_queue","high_quality","music_off","video_camera_back","spatial_audio_off","shuffle_on","playlist_add_circle","volume_down_alt","hearing_disabled","featured_video","replay_5","repeat_on","queue_play_next","spatial_audio","art_track","explicit","airplay","speech_to_text","forward_30","forward_5","4k","music_video","replay_30","spatial_tracking","control_camera","closed_caption_disabled","digital_out_of_home","video_label","fiber_smart_record","play_disabled","repeat_one_on","broadcast_on_personal","sd","missed_video_call","surround_sound","10k","fiber_pin","60fps","sound_detection_glass_break","remove_from_queue","broadcast_on_home","fiber_dvr","30fps","4k_plus","video_stable","8k","1k","privacy","8k_plus","2k","7k","1k_plus","9k","9k_plus","5k","2k_plus","5k_plus","6k","6k_plus","3k","7k_plus","3k_plus","auto_detect_voice","cinematic_blur","media_link","video_camera_front_off","autoplay","forward_media","movie_edit","auto_videocam","resume","select_to_speak","autopause","forward_circle","autostop","sound_sampler","frame_person_off","view_in_ar_off","local_shipping","local_shipping","directions_car","flight","directions_run","directions_walk","flight_takeoff","directions_bus","directions_bike","train","airport_shuttle","pedal_bike","directions_boat","two_wheeler","agriculture","local_taxi","sailing","electric_car","flight_land","hail","no_crash","commute","motorcycle","car_crash","tram","departure_board","subway","electric_moped","turn_right","electric_scooter","fork_right","directions_subway","tire_repair","electric_bike","rv_hookup","bus_alert","turn_left","transportation","airlines","taxi_alert","u_turn_left","directions_railway","electric_rickshaw","turn_slight_right","u_turn_right","fork_left","railway_alert","bike_scooter","turn_sharp_right","turn_slight_left","no_transfer","snowmobile","turn_sharp_left","ambulance","school","school","campaign","construction","engineering","volunteer_activism","science","sports_esports","confirmation_number","real_estate_agent","cake","self_improvement","sports_soccer","air","biotech","water","hiking","architecture","sports_score","personal_injury","sports_basketball","waves","theaters","sports_tennis","switch_account","nights_stay","sports_gymnastics","backpack","sports_motorsports","how_to_vote","sports_kabaddi","surfing","piano","sports","toys","sports_volleyball","sports_martial_arts","sports_baseball","camping","downhill_skiing","swords","scoreboard","kayaking","phishing","sports_handball","sports_football","skateboarding","sports_golf","sports_cricket","toys_fan","nordic_walking","roller_skating","kitesurfing","rowing","scuba_diving","storm","sports_mma","paragliding","snowboarding","sports_hockey","ice_skating","snowshoeing","sports_rugby","sledding","piano_off","no_backpack","cake_add","sprint","health_metrics","mindfulness","sleep","stress_management","exercise","steps","relax","ecg_heart","readiness_score","avg_time","distance","menstrual_health","laps","onsen","podiatry","floor","azm","bath_outdoor","bia","fertile","avg_pace","eda","pace","person_play","person_celebrate","water_medium","interactive_space","spo2","water_full","elevation","sauna","bath_private","glass_cup","hr_resting","monitor_weight_gain","sleep_score","water_loss","bath_public_large","check_in_out","thermometer_loss","monitor_weight_loss","physical_therapy","play_shapes","thermometer_gain","phone_iphone","phone_iphone","save","smartphone","print","keyboard_arrow_down","computer","devices","desktop_windows","smart_display","dns","keyboard_backspace","headphones","smart_toy","phone_android","keyboard_arrow_right","memory","live_tv","keyboard","laptop_mac","headset_mic","keyboard_arrow_up","tv","device_thermostat","mouse","balance","route","point_of_sale","keyboard_arrow_left","laptop_chromebook","keyboard_return","power","watch","laptop_windows","router","developer_board","display_settings","scale","book_online","fax","developer_mode","cast","cast_for_education","videogame_asset","device_hub","straight","screen_search_desktop","desktop_mac","settings_ethernet","settings_input_antenna","mobile_friendly","monitor","important_devices","tablet_mac","devices_other","send_to_mobile","system_update","settings_remote","monitor_weight","screen_rotation","screen_share","keyboard_alt","settings_input_component","speaker","sim_card","merge","keyboard_tab","vibration","power_off","connected_tv","screenshot_monitor","remember_me","tablet","browser_updated","security_update_good","sd_card","cast_connected","device_unknown","tablet_android","charging_station","phonelink_setup","punch_clock","scanner","screenshot","settings_input_hdmi","stay_current_portrait","tap_and_play","keyboard_hide","print_disabled","security_update_warning","disc_full","app_blocking","keyboard_capslock","speaker_group","mobile_screen_share","aod","sd_card_alert","tty","lift_to_talk","add_to_home_screen","earbuds","perm_device_information","stop_screen_share","mobile_off","headset_off","desktop_access_disabled","reset_tv","offline_share","adf_scanner","headphones_battery","screen_lock_portrait","roundabout_right","dock","settop_component","settings_input_svideo","watch_off","smart_screen","stay_current_landscape","chromecast_device","settings_cell","earbuds_battery","home_max","power_input","no_sim","screen_lock_landscape","ramp_right","developer_board_off","roundabout_left","stay_primary_portrait","stay_primary_landscape","tv_off","home_mini","phonelink_off","ramp_left","screen_lock_rotation","videogame_asset_off","aod_tablet","gamepad","robot","devices_wearables","ambient_screen","rear_camera","aod_watch","ecg","hard_drive","night_sight_max","devices_off","pacemaker","screenshot_tablet","touchpad_mouse","memory_alt","stream_apps","watch_wake","camera_video","deskphone","hard_drive_2","lda","print_add","print_connect","print_error","print_lock","ventilator","watch_button_press","dark_mode","dark_mode","light_mode","wifi","signal_cellular_alt","password","widgets","pin","storage","rss_feed","battery_full","android","wifi_off","bluetooth","battery_charging_full","dvr","thermostat","graphic_eq","nightlight","battery_5_bar","signal_wifi_4_bar","gpp_maybe","cable","gpp_bad","data_usage","battery_4_bar","battery_full_alt","signal_cellular_4_bar","airplanemode_active","radar","battery_0_bar","cameraswitch","wallpaper","signal_disconnected","flashlight_on","network_check","battery_6_bar","charger","wifi_tethering","sim_card_download","usb","quick_phrases","splitscreen","battery_3_bar","battery_1_bar","adb","network_wifi_3_bar","battery_low","battery_alert","bluetooth_searching","network_wifi","bluetooth_connected","wifi_find","5g","battery_2_bar","brightness_high","network_cell","nfc","pattern","data_saver_on","bluetooth_disabled","signal_wifi_statusbar_not_connected","signal_wifi_bad","signal_cellular_3_bar","noise_control_off","network_wifi_2_bar","network_wifi_1_bar","signal_wifi_off","brightness_medium","mode_standby","brightness_low","battery_very_low","mobiledata_off","signal_wifi_0_bar","grid_4x4","battery_charging_20","battery_charging_80","battery_saver","battery_charging_90","flashlight_off","signal_wifi_statusbar_null","settings_system_daydream","battery_charging_50","battery_unknown","signal_cellular_2_bar","screen_rotation_alt","wifi_calling_3","badge_critical_battery","4g_mobiledata","signal_cellular_1_bar","noise_aware","battery_charging_60","nearby_error","wifi_lock","do_not_disturb_on_total_silence","signal_cellular_connected_no_internet_0_bar","battery_20","battery_charging_30","signal_cellular_0_bar","network_ping","brightness_auto","wifi_tethering_error","edgesensor_high","wifi_calling_1","signal_cellular_connected_no_internet_4_bar","wifi_2_bar","battery_30","battery_50","airplanemode_inactive","grid_3x3","lte_mobiledata","perm_data_setting","1x_mobiledata","signal_cellular_alt_2_bar","battery_60","bluetooth_drive","signal_cellular_nodata","perm_scan_wifi","devices_fold","battery_90","wifi_calling_2","4g_plus_mobiledata","media_bluetooth_on","network_locked","signal_cellular_off","battery_80","timer_10_select","wifi_tethering_off","signal_cellular_alt_1_bar","edgesensor_low","usb_off","wifi_1_bar","3g_mobiledata","apk_install","signal_cellular_null","lte_plus_mobiledata","grid_goldenratio","g_mobiledata","portable_wifi_off","noise_control_on","media_bluetooth_off","timer_3_select","e_mobiledata","apk_document","nearby_off","h_mobiledata","r_mobiledata","h_plus_mobiledata","dual_screen","screenshot_region","overview_key","battery_status_good","dock_to_left","dock_to_right","magic_tether","magnify_fullscreen","keyboard_external_input","keyboard_off","magnify_docked","1x_mobiledata_badge","5g_mobiledata_badge","backlight_low","battery_plus","brightness_empty","display_external_input","dock_to_bottom","keyboard_capslock_badge","keyboard_full","keyboard_keys","lte_mobiledata_badge","screen_record","screenshot_keyboard","3g_mobiledata_badge","4g_mobiledata_badge","backlight_high","battery_change","battery_error","battery_share","e_mobiledata_badge","ev_mobiledata_badge","g_mobiledata_badge","grid_3x3_off","h_mobiledata_badge","h_plus_mobiledata_badge","keyboard_onscreen","keyboard_previous_language","lte_plus_mobiledata_badge","screen_rotation_up","screenshot_frame","splitscreen_bottom","splitscreen_left","splitscreen_right","splitscreen_top","wallpaper_slideshow","wifi_home","wifi_notification","badge","badge","verified_user","admin_panel_settings","report","security","vpn_key","shield","policy","exclamation","privacy_tip","assured_workload","vpn_lock","disabled_visible","e911_emergency","enhanced_encryption","private_connectivity","vpn_key_off","add_moderator","no_encryption","sync_lock","wifi_password","key_visualizer","remove_moderator","report_off","shield_lock","shield_person","vpn_key_alert","apartment","apartment","location_city","fitness_center","lunch_dining","spa","cottage","local_cafe","hotel","family_restroom","beach_access","local_bar","pool","other_houses","luggage","liquor","airplane_ticket","casino","sports_bar","bakery_dining","ramen_dining","nightlife","local_dining","holiday_village","icecream","escalator_warning","dinner_dining","museum","food_bank","night_shelter","festival","attractions","golf_course","stairs","villa","smoke_free","smoking_rooms","car_rental","airline_seat_recline_normal","elevator","gite","child_friendly","airline_seat_recline_extra","breakfast_dining","carpenter","car_repair","cabin","brunch_dining","no_food","houseboat","do_not_touch","rice_bowl","tapas","wheelchair_pickup","bento","no_drinks","do_not_step","airline_seat_flat","bungalow","airline_seat_individual_suite","escalator","chalet","no_luggage","airline_seat_legroom_extra","airline_seat_flat_angled","airline_seat_legroom_normal","airline_seat_legroom_reduced","no_stroller","house","house","bed","ac_unit","chair","coffee","electric_bolt","child_care","sensors","back_hand","checkroom","emergency_home","grass","shower","mode_fan","mop","kitchen","room_service","thermometer","styler","yard","bathtub","king_bed","roofing","energy_savings_leaf","window","cooking","valve","garage_home","door_front","mode_heat","light","foundation","outdoor_grill","garage","dining","table_restaurant","deck","sensor_occupied","weekend","coffee_maker","flatware","humidity_high","fireplace","highlight","mode_night","humidity_low","electric_meter","tv_gen","humidity_mid","bedroom_parent","chair_alt","blender","microwave","scene","single_bed","heat_pump","oven_gen","bedroom_baby","bathroom","in_home_mode","hot_tub","mode_off_on","hardware","sprinkler","table_bar","gas_meter","crib","soap","countertops","living","mode_cool","home_iot_device","fire_extinguisher","propane_tank","outlet","remote_gen","sensor_door","gate","airware","event_seat","matter","faucet","dishwasher_gen","balcony","energy_program_saving","air_freshener","wash","camera_indoor","water_damage","bedroom_child","house_siding","microwave_gen","switch","detector_smoke","door_sliding","iron","energy_program_time_used","desk","water_heater","umbrella","dresser","door_back","doorbell","fence","mode_fan_off","hvac","camera_outdoor","kettle","emergency_heat","air_purifier_gen","emergency_share","stroller","google_wifi","curtains","multicooker","shield_moon","sensors_off","mode_heat_cool","thermostat_auto","emergency_recording","smart_outlet","blinds","controller_gen","roller_shades","dry","blinds_closed","roller_shades_closed","propane","sensor_window","thermostat_carbon","range_hood","doorbell_3p","blanket","tv_with_assistant","vertical_shades_closed","vertical_shades","curtains_closed","mode_heat_off","mode_cool_off","tamper_detection_off","shelves","stadia_controller","stadia_controller","temp_preferences_custom","door_open","power_rounded","nest_eco_leaf","device_reset","nest_clock_farsight_analog","nest_remote_comfort_sensor","laundry","battery_horiz_075","shield_with_heart","temp_preferences_eco","familiar_face_and_zone","tools_power_drill","airwave","productivity","battery_horiz_050","nest_heat_link_gen_3","nest_display","weather_snowy","activity_zone","ev_charger","nest_remote","cleaning_bucket","settings_alert","nest_cam_indoor","arrows_more_up","nest_heat_link_e","home_storage","nest_multi_room","nest_secure_alarm","battery_horiz_000","nest_cam_outdoor","light_group","detection_and_zone","nest_thermostat_gen_3","mfg_nest_yale_lock","tools_pliers_wire_stripper","nest_cam_iq_outdoor","tools_ladder","detector_alarm","nest_cam_iq","nest_clock_farsight_digital","early_on","floor_lamp","nest_mini","auto_activity_zone","home_speaker","auto_schedule","home_max_dots","nest_hello_doorbell","nest_audio","nest_wifi_router","house_with_shield","zone_person_urgent","motion_sensor_active","nest_display_max","cool_to_dry","nest_farsight_weather","shield_with_house","chromecast_2","battery_profile","window_closed","heat_pump_balance","arming_countdown","nest_found_savings","self_care","battery_vert_050","detector_status","tools_level","window_open","nest_thermostat_zirconium_eu","arrows_more_down","nest_true_radiant","nest_cam_wired_stand","zone_person_alert","climate_mini_split","detector","nest_detect","nest_wifi_mistral","nest_wifi_point","quiet_time","door_sensor","nest_cam_floodlight","nest_doorbell_visitor","nest_tag","tools_installation_kit","battery_vert_020","nest_connect","battery_vert_005","nest_thermostat_sensor_eu","nest_thermostat_sensor","tools_phillips","nest_sunblock","nest_wifi_gale","nest_wifi_point_vento","nest_thermostat_e_eu","doorbell_chime","detector_co","detector_battery","tools_flat_head","nest_wake_on_approach","nest_wake_on_press","motion_sensor_urgent","motion_sensor_alert","window_sensor","table_lamp","tamper_detection_on","nest_cam_magnet_mount","zone_person_idle","quiet_time_active","nest_cam_stand","detector_offline","nest_cam_wall_mount","wall_lamp","nest_locator_tag","motion_sensor_idle","assistant_on_hub","g_translate","g_translate","launcher_assistant_on","fitbit_hourly_activity","nightlight_off","blood_pressure","blood_pressure","keyboard_tab_rtl","contrast_rtl_off"]'
    );

    CBS.addElement('material-icon', CBS_MaterialIcon);

    prefix = prefix ? prefix + '-' : '';
    const i = new CBS_MaterialIcon();

    icons.forEach(icon => {
        icon = prefix + icon;
        // buttons
        const btn = new CBS_Button();

        i.icon = icon;
        btn.content = i;

        CBS_Button.addTemplate(icon, btn);

        // texts
        [
            CBS_H1,
            CBS_H2,
            CBS_H3,
            CBS_H4,
            CBS_H5,
            CBS_H6,
            CBS_Component,
            CBS_Anchor
        ].forEach(c => {
            const el = new c();
            el.append(i.clone());

            c.addTemplate(icon, el);
        });
    });
};

